# This file was created automatically by SWIG.
import preconditionerc
from ooflib.SWIG.common.doublevec import DoubleVecPtr
class PreconditionerBasePtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_PreconditionerBase(self)
    def solve(self, *_args, **_kwargs):
        val = apply(preconditionerc.PreconditionerBase_solve,(self,) + _args, _kwargs)
        if val: val = DoubleVecPtr(val) ; val.thisown = 1
        return val
    def trans_solve(self, *_args, **_kwargs):
        val = apply(preconditionerc.PreconditionerBase_trans_solve,(self,) + _args, _kwargs)
        if val: val = DoubleVecPtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C PreconditionerBase instance at %s>" % (self.this,)
class PreconditionerBase(PreconditionerBasePtr):
    def __init__(self,this):
        self.this = this




class PreconditionerPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_Preconditioner(self)
    def create_preconditioner(self, *_args, **_kwargs):
        val = apply(preconditionerc.Preconditioner_create_preconditioner,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C Preconditioner instance at %s>" % (self.this,)
class Preconditioner(PreconditionerPtr):
    def __init__(self,this):
        self.this = this




class ILUPreconditionerPtr(PreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_ILUPreconditioner(self)
    def __repr__(self):
        return "<C ILUPreconditioner instance at %s>" % (self.this,)
class ILUPreconditioner(ILUPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_ILUPreconditioner,_args,_kwargs)
        self.thisown = 1




class ICPreconditionerPtr(PreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_ICPreconditioner(self)
    def __repr__(self):
        return "<C ICPreconditioner instance at %s>" % (self.this,)
class ICPreconditioner(ICPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_ICPreconditioner,_args,_kwargs)
        self.thisown = 1




class UnPreconditionerPtr(PreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_UnPreconditioner(self)
    def __repr__(self):
        return "<C UnPreconditioner instance at %s>" % (self.this,)
class UnPreconditioner(UnPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_UnPreconditioner,_args,_kwargs)
        self.thisown = 1




class JacobiPreconditionerPtr(PreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_JacobiPreconditioner(self)
    def __repr__(self):
        return "<C JacobiPreconditioner instance at %s>" % (self.this,)
class JacobiPreconditioner(JacobiPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_JacobiPreconditioner,_args,_kwargs)
        self.thisown = 1




class UnconditionerCorePtr(PreconditionerBasePtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_UnconditionerCore(self)
    def __repr__(self):
        return "<C UnconditionerCore instance at %s>" % (self.this,)
class UnconditionerCore(UnconditionerCorePtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_UnconditionerCore,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: preconditioner.spy,v $
# $Revision: 1.6 $
# $Author: langer $
# $Date: 2011-04-06 19:52:30 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from ooflib.common import cregisteredclass
from ooflib.common.IO import parameter
from ooflib.common.IO import xmlmenudump
from types import *

cregisteredclass.registerCClass(PreconditionerPtr)

PreconditionerPtr.tip = \
                "Preconditioners for efficient solution of matrix equations."
PreconditionerPtr.discussion = xmlmenudump.loadFile(
    'DISCUSSIONS/engine/reg/preconditioner.xml')

iluPreconditioner = cregisteredclass.Registration(
    "ILU",
    PreconditionerPtr,
    ILUPreconditioner,
    ordering=100,
    params=[],
    tip="Incomplete LU-factorization",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/ilu_preconditioner.xml')
    )

cregisteredclass.Registration(
    "IC",
    PreconditionerPtr,
    ICPreconditioner,
    ordering=200,
    params=[],
    tip="Incomplete Cholesky preconditioner. Appropriate only for meshes with symmetric, positive definite stiffness matrices.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/ic_preconditioner.xml'))

cregisteredclass.Registration(
    "Null",
    PreconditionerPtr,
    UnPreconditioner,
    ordering=2000,
    params=[],
    tip="Be bold (or foolhardy) and attempt to solve the mesh without a preconditioner",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/null_preconditioner.xml'))

cregisteredclass.Registration(
    "Jacobi",
    PreconditionerPtr,
    JacobiPreconditioner,
    ordering=500,
    params=[],
    tip="A light-weight preconditioner, that simply inverts the diagonal part of the matrix.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/jacobi_preconditioner.xml'))

